/*
 * OpenAPI definition
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.gitlab.rcktsci.hackatons.x5.codegen.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.v3.oas.annotations.media.Schema;

import java.util.Objects;

/**
 * Продукт (товар) находится либо на складе либо может быть выложен на полку в магазине. Один продукт может лежать только на одной полке. Продукт на склад
 * можно докупить по закупочной цене. И выставить на полку по любой цене. Чем дороже цена, тем сложнее покупателям купить товар.
 */
@Schema(description = "Продукт (товар) находится либо на складе либо может быть выложен на полку в магазине. Один продукт может лежать только на одной полке."
                      + " Продукт на склад можно докупить по закупочной цене. И выставить на полку по любой цене. Чем дороже цена, тем сложнее покупателям "
                      + "купить товар.")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2021-08-29T20:10:20.018547+03:00[Europe/Moscow]")
public class Product {

    @SerializedName("id")
    private Integer id = null;

    @SerializedName("name")
    private String name = null;

    @SerializedName("stockPrice")
    private Double stockPrice = null;

    @SerializedName("inStock")
    private Integer inStock = null;

    @SerializedName("sellPrice")
    private Double sellPrice = null;

    public Product id(Integer id) {
        this.id = id;
        return this;
    }

    /**
     * Id продукта
     *
     * @return id
     **/
    @Schema(description = "Id продукта")
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Product name(String name) {
        this.name = name;
        return this;
    }

    /**
     * Название продукта
     *
     * @return name
     **/
    @Schema(description = "Название продукта")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Product stockPrice(Double stockPrice) {
        this.stockPrice = stockPrice;
        return this;
    }

    /**
     * Закупочная цена
     *
     * @return stockPrice
     **/
    @Schema(description = "Закупочная цена")
    public Double getStockPrice() {
        return stockPrice;
    }

    public void setStockPrice(Double stockPrice) {
        this.stockPrice = stockPrice;
    }

    public Product inStock(Integer inStock) {
        this.inStock = inStock;
        return this;
    }

    /**
     * Количество товара на складе
     *
     * @return inStock
     **/
    @Schema(description = "Количество товара на складе")
    public Integer getInStock() {
        return inStock;
    }

    public void setInStock(Integer inStock) {
        this.inStock = inStock;
    }

    public Product sellPrice(Double sellPrice) {
        this.sellPrice = sellPrice;
        return this;
    }

    /**
     * Цена для покупателя. Если товар не выставлен на полку, то цена может быть не проставлена
     *
     * @return sellPrice
     **/
    @Schema(description = "Цена для покупателя. Если товар не выставлен на полку, то цена может быть не проставлена")
    public Double getSellPrice() {
        return sellPrice;
    }

    public void setSellPrice(Double sellPrice) {
        this.sellPrice = sellPrice;
    }

    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Product product = (Product) o;
        return Objects.equals(this.id, product.id) &&
               Objects.equals(this.name, product.name) &&
               Objects.equals(this.stockPrice, product.stockPrice) &&
               Objects.equals(this.inStock, product.inStock) &&
               Objects.equals(this.sellPrice, product.sellPrice);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, stockPrice, inStock, sellPrice);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Product {\n");

        sb.append("    id: ").append(toIndentedString(id)).append("\n");
        sb.append("    name: ").append(toIndentedString(name)).append("\n");
        sb.append("    stockPrice: ").append(toIndentedString(stockPrice)).append("\n");
        sb.append("    inStock: ").append(toIndentedString(inStock)).append("\n");
        sb.append("    sellPrice: ").append(toIndentedString(sellPrice)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}
